﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TetraminoSolver
{
    class ProblemSet
    {
        public Board       BaseBoard  = null;
        public Tetramino[] Tetraminos = null;
    }

    class PartialSolution : ICloneable
    {
        public ProblemSet Problem      = null;
        public Board CurrentBoard      = null;
        public int LastPlacedTetramino = -1;

        public PartialSolution( ProblemSet problem )
        {
            Problem = problem;
            CurrentBoard = (Board)Problem.BaseBoard.Clone();
        }

        public object Clone()
        {
            PartialSolution o = (PartialSolution)this.MemberwiseClone();
            o.CurrentBoard = (Board)this.CurrentBoard.Clone();
            return o;
        }
    }

}
