﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace TetraminoSolver
{
    class Program
    {
        static void Main(string[] args)
        {   
            var ps = new ProblemSet();
            ps.BaseBoard = new Board(7,4);
            ps.Tetraminos = new Tetramino[]
            {
                //new Tetramino(Tetramino.Pattern.Square),
                new Tetramino(Tetramino.Pattern.Line),
                new Tetramino(Tetramino.Pattern.T),
                new Tetramino(Tetramino.Pattern.T),
                new Tetramino(Tetramino.Pattern.L_Left),
                new Tetramino(Tetramino.Pattern.L_Right),
                new Tetramino(Tetramino.Pattern.S_Left),
                new Tetramino(Tetramino.Pattern.S_Left),
                //new Tetramino(Tetramino.Pattern.S_Right)
            };

            var bs = new BacktrackSolver();
            var sol = bs.Solve(ps);

            System.Console.WriteLine( sol.ToString() );
            System.Console.ReadLine();
        }
    }
}
